from tkinter import *
from tkinter import messagebox
from tkinter import filedialog
from tkinter import scrolledtext


import os
import random, math
#■範囲チェック
def rangeD(D, D1, D2):
    if D<D1: return D1
    if D>D2: return D2
    return D

#■色のクラス
class Color:
    def __init__(self, R=0, G=0, B=0, ColorSV=0.5):
        self.R=R
        self.G=G
        self.B=B
        self.ColorSV=ColorSV
    #■標高値による色の設定
    def setColor(self,Z, N):
        SZ = 0
        for i in range(N): SZ += Z[i]
        R = int((SZ / (N * 4) + 1.001) * self.ColorSV * 127)
        if R >= 512: return Color(255, 0, 0, self.ColorSV)
        if R >= 384: return Color(255, 255 - 2 * (R - 384), 0, self.ColorSV)
        if R >= 256: return Color((R - 256) * 2, 255, 0, self.ColorSV)
        if R >= 128: return Color(0, R, 0, self.ColorSV)
        if R < 0 :
            if R < -510 : return self.Color(255, 127, 127, self.ColorSV)
            return Color(-int(R / 2), -int(R / 4), 127, self.ColorSV )
        return Color(0, R, 177 - R, self.ColorSV)
    #■Python用色指定に変換
    def toString(self):
        R=rangeD(self.R, 0, 255)
        G=rangeD(self.G, 0, 255)
        B=rangeD(self.B, 0, 255)
        return "#%02X%02X%02X" % (R,G,B)
#■Python用配列宣言
def array(N1, N2=0, N3=0):
    if N2 == 0 and N3==0:
        return [0 for i in range(N1)]
    elif N3 == 0:
        return [[0 for i in range(N2)] for j in range(N1)]
    else:
        return [[[0 for i in range(N3)] for j in range(N2)] for k in range(N1)]
#■初期設定
NumX = 64; NumY = 64
Z=array(NumX + 1, NumY + 1)
# 隠し線処理/表示用値
PI=math.pi
dlx = 0.1; alpha = PI / 12; beta = PI / 8; dx = 2; dy = 1.4
dxCosA = dx * math.cos(alpha)   ; dyCosB = dy * math.cos(beta)
dxSinA = dx * math.sin(alpha)   ; dySinB = dy * math.sin(beta)
Xlen = (NumX - 1) * dxCosA      ; Ylen = (NumY - 1) * dyCosB
dlxTanA  = dlx * math.tan(alpha); dlxTanB = dlx * math.tan(beta)
ZeroP = 0.5
# 地形生成用値
seaFlag  = True # 負の標高値のとき 0 にするときTrue(チェックボタンで指定) 
Steep    = 0.5  # 地形の険しさ(テキストボックスで指定)
middleV  = 0.0  # 中央の初期値(テキストボックスで指定)
arroundV = 0.0  # 周辺の初期値(テキストボックスで指定)
#■共通関数
def GroundX(j , k): # X0=Y0=0のときのX座標
    global dxCosA, dyCosB
    return dxCosA * j - dyCosB * k
def GroundY(j, k): # X0=Y0=0のときのY座標
    global dxSinA, dySinB
    return dxSinA * j + dySinB * k
def DrawPos(j, k): #  表示位置
    global Ylen, dlx
    return (0.5 + (Ylen + GroundX(j, k) / dlx))
def setPx(j, k, X0, PH):# スクリーン X 座標(x = j, y= k)
    global dlx
    return PH * dlx + GroundX(j, k) + X0
def setPy(j, k, Y0, PH, fp):# スクリーン Y 座標(x = j, y= k)
    global dlxTanA
    return PH * dlxTanA + GroundY(j, k) + fp + Y0
#def setPy2(j, k, Y0, PH, fp):
#    global dlxTanA 
#    return -PH * dlxTanA + GroundY(j, k) + fp + Y0
#■ランダム地形生成
def setMap(L, U, W, dH):
    global Zerop, Z, Steep
    if W < 2 : return
    DW = W; WW = int(DW / 2); RZ = 1 - ZeroP
    Z[L + WW][U] = (Z[L + W][U] + Z[L][U]) * 0.5 + dH * (random.random() - RZ)
    Z[L + WW][U + W] = (Z[L + W][U + W] + Z[L][U + W]) * 0.5 + dH * (random.random() - RZ)
    Z[L][U + WW] = (Z[L][U] + Z[L][U + W]) * 0.5 + dH * (random.random() - RZ)
    Z[L + W][U + WW] = (Z[L + W][U + W] + Z[L + W][U]) * 0.5 + dH * (random.random() - RZ)
    Z[L + WW][U + WW] = (Z[L + WW][U] + Z[L + WW][U + W]+
                         Z[L][U + WW] + Z[L + W][U + WW]) * 0.25 + dH * (random.random() - RZ) * 0.5
    setMap(L     , U     , WW, dH * Steep) # 左上生成
    setMap(L + WW, U     , WW, dH * Steep) # 右上生成
    setMap(L     , U + WW, WW, dH * Steep) # 左下生成
    setMap(L + WW, U + WW, WW, dH * Steep) # 右下生成
#■標高値データの初期設定とランダム地形生成呼び出し
def setData(): 
    global Z, arroundV, middleV, Steep, seaFlag, NumX, NumY
    for j in range(NumX+1):   # 周辺を初期設定
        Z[j][  0 ] = arroundV; Z[j][NumY] = arroundV
    for j in range(NumY+1):
        Z[  0 ][j] = arroundV; Z[NumX][0] = arroundV
    DW =float(NumX); WW = int(DW / 2)
    Z[WW][WW] = middleV       # 中央を初期設定
    setMap( 0,  0, WW, Steep) # 左上生成
    setMap(WW,  0, WW, Steep) # 右上生成
    setMap( 0, WW, WW, Steep) # 左下生成
    setMap(WW, WW, WW, Steep) # 右下生成
    for i in range(1,6): # 平均化することで刺々しさを緩和する
        for k in range(1,NumY):
            Z[0][k] = (Z[1][k] + Z[0][k-1] + Z[0][k+1] + Z[0][k] * 2) / 5
        for j in range(1,NumX):
            Z[j][0] = (Z[j-1][0] + Z[j+1][0] + Z[j][1] + Z[j][0] * 2) / 5
            for k in range(1, NumY):
                Z[j][k] = (Z[j-1][k] + Z[j+1][k] + Z[j][k-1] + Z[j][k+1] + Z[j][k] * 2) / 6
    for j in range(NumX+1): # 負の標高値を０にし、かつ標高値を100倍する
        for k in range(NumY+1):
            if seaFlag and Z[j][k] < 0: Z[j][k] = 0
            else: Z[j][k] *= 100
#--------------描画用関数-----------------------------------
#■スクリーン座標系変換
def screenX(X): return int(20 + X * 2 + 0.5)
def screenY(Y): return int(400 - Y * 2 + 0.5)
#■四角形描画   
def drawTetragon(X, Y, C, CC):
    global canvas
    p=[]
    for i in range(4):
        p.append(screenX(X[i])); p.append(screenY(Y[i]))
    canvas.create_polygon(p,fill=C.toString(), outline=CC.toString(), tag="DT")
#■有効標高値の設定
def getZ(j, k):
    global Z; R = Z[j][k]
    if R > -999: return R
    for jj in range(j-1, j+2):
        for kk in range(k-1, k+2):
            if Z[jj][kk] >-999 and Z[jj][kk]<R: R = Z[jj][kk]
    return R
#■描画周りのXYZ値を四角形の３Ｄ座標値として求める
def setSquareXYZ(X0, Y0, j, k):
    jj = j - 1; kk = k - 1; AZ=array(4); AX=array(4); AY=array(4)
    AZ[0] = getZ( j,  k); AZ[1] = getZ( j, kk)
    AZ[2] = getZ(jj, kk); AZ[3] = getZ(jj,  k)
    AX[0] = setPx( j,  k, X0, 0) ; AY[0] = setPy( j,  k, Y0, 0, AZ[0])
    AX[1] = setPx( j, kk, X0, 0) ; AY[1] = setPy( j, kk, Y0, 0, AZ[1])
    AX[2] = setPx(jj, kk, X0, 0) ; AY[2] = setPy(jj, kk, Y0, 0, AZ[2])
    AX[3] = setPx(jj,  k, X0, 0) ; AY[3] = setPy(jj,  k, Y0, 0, AZ[3])
    return [AX, AY, AZ]
#■隠れ線処理
def hiddenLine(): #　画面の場合のみ可能（プロッタでは使えない）
    global canvas, NumX, NumY,Z
    canvas.delete("DT")
    X0 = 80; Y0 = 100; maxS = 0
    TX=array(3); TY=array(3); TZ=array(3)
    k=NumY-2; CC=Color(0,0,0)
    while k>=1:
        j=NumX-2
        while j>=1:
            if(Z[j][ k ] > -999 or Z[j-1][ k ] > -999 or
               Z[j][k-1] > -999 or Z[j-1][k-1] > -999 ): #標高値なしを省く
                RX = setSquareXYZ(X0, Y0, j, k)
                AX = RX[0]; AY=RX[1]; AZ=RX[2]
                C=CC.setColor(AZ,4)
                drawTetragon(AX, AY, C, Color(0,0,0)) #四角形枠線描画
            j -= 1
        k -= 1
#■地形の表示
def drawLand():
    global opt1,seaFlag, Steep, arroundV,middleV
    Steep    = float(textBox1.get("1.0",END)) # 地形の険しさ    ( 0.0～1.0)
    arroundV = float(textBox2.get("1.0",END)) # 周囲の標高初期値(-1.0～1.0)
    middleV  = float(textBox3.get("1.0",END)) # 中央の標高初期値(-1.0～1.0)
    seaFlag  = opt1.get()                     # 標高負のとき0にするかどうか
    setData()                                 # 地形の生成
    hiddenLine()                              # 地形表示(隠れ線の処理)
    root.update()
#■ファイル出力
def outData():
    global NumX, NumY,Z
    fn=filedialog.asksaveasfilename(filetypes=[('Text Files', '*.txt'),
                                               ('CSV Files', '*.csv'),
                                               ('All Files', '*.*')])
    if fn:
        try:
            s=""
            for i in range(NumY+1):
                s += "%12.4E" % Z[i][0]
                for j in range(NumX+1):
                    s += ", %12.4E" % Z[i][j]
                s=s+ "\n"
            f=open(fn,'w'); f.write(s);f.close()
        except:
            print("出力/変換時にエラーが起きました")
#■ファイル入力
def inputData():
    global NumX, NumY,Z
    fn=filedialog.askopenfilename(filetypes=[('Text Files', '*.txt'),
                                             ('CSV Files', '*.csv'),
                                             ('All Files', '*.*')])
    if fn:
        try:
            f=open(fn,'rt'); s=f.read(); f.close()
            for i in range(NumY):
                for j in range(NumX): Z[i][j]=-999
            dt=""; i=0; j=0; N=len(s); k=0
            while i<=NumY and k<N:
                if s[k]=='\n': # 行エンドで値設定と i += 1 j=0
                    if j<=NumX and dt !="": Z[i][j] = float(dt)
                    i+=1; j=0; dt=""
                elif s[k]==',': # コンマで値設定と j +=1
                    if j<=NumX and dt !="": Z[i][j] = float(dt)
                    dt=""; j += 1
                elif s[k]!=' ' and s[k]!='　': dt+=s[k] # 空白は無視
                k+=1
            hiddenLine(); root.update()
        except:
            print("入力/変換時にエラーが起きました")
#■メイン処理
root=Tk()
root.title("ランダム地形")
root.geometry("460x400")
opt1=BooleanVar()
opt1.set(True)
check1=Checkbutton(text='負の標高を0とする', variable=opt1)
check1.pack(anchor='n',side='left')
button1=Button(root,text='描画', command=drawLand)
button1.pack(anchor='n',side='left')
button2=Button(root,text='標高値出力', command=outData)
button2.pack(anchor='n',side='left')
button3=Button(root,text='標高値入力', command=inputData)
button3.pack(anchor='n',side='left')

Label(root,text="周囲/中央の初期値は -1.0～1.0で指定してください").place(x=170,y=40)

Label(root,text="地形の険しさ(0～1)").place(x=0,y=60)
textBox1=Text(root,width=5, height=1)
textBox1.insert(INSERT, "0.5")
textBox1.place(x=120,y=65)

Label(root,text="周囲の初期値").place(x=170,y=60)
textBox2=Text(root,width=5, height=1)
textBox2.insert(INSERT, "0.0")
textBox2.place(x=260,y=65)

Label(root,text="中央の初期値").place(x=320,y=60)
textBox3=Text(root,width=5, height=1)
textBox3.insert(INSERT, "0.0")
textBox3.place(x=400,y=65)

canvas=Canvas(root, width=460,height=400)
canvas.place(x=0,y=100)
root.mainloop()







    
